# coding: utf-8

"""
    Deep Lynx

    The construction of megaprojects has consistently demonstrated challenges for project managers in regard to meeting cost, schedule, and performance requirements. Megaproject construction challenges are common place within megaprojects with many active projects in the United States failing to meet cost and schedule efforts by significant margins. Currently, engineering teams operate in siloed tools and disparate teams where connections across design, procurement, and construction systems are translated manually or over brittle point-to-point integrations. The manual nature of data exchange increases the risk of silent errors in the reactor design, with each silent error cascading across the design. These cascading errors lead to uncontrollable risk during construction, resulting in significant delays and cost overruns. Deep Lynx allows for an integrated platform during design and operations of mega projects.  The Deep Lynx Core API delivers a few main features.  1. Provides a set of methods and endpoints for manipulating data in an object oriented database. This allows us to store complex datatypes as records and then to compile them into actual, modifiable objects at run-time. Users can store taxonomies or ontologies in a readable format.  2. Provides methods for storing and retrieving data in a graph database. This data is structured and validated against the aformentioned object oriented database before storage.  # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class TypeMappingExportPayload(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'mapping_ids': 'list[str]',
        'target_data_source': 'str'
    }

    attribute_map = {
        'mapping_ids': 'mapping_ids',
        'target_data_source': 'target_data_source'
    }

    def __init__(self, mapping_ids=None, target_data_source=None):  # noqa: E501
        """TypeMappingExportPayload - a model defined in Swagger"""  # noqa: E501
        self._mapping_ids = None
        self._target_data_source = None
        self.discriminator = None
        self.mapping_ids = mapping_ids
        if target_data_source is not None:
            self.target_data_source = target_data_source

    @property
    def mapping_ids(self):
        """Gets the mapping_ids of this TypeMappingExportPayload.  # noqa: E501


        :return: The mapping_ids of this TypeMappingExportPayload.  # noqa: E501
        :rtype: list[str]
        """
        return self._mapping_ids

    @mapping_ids.setter
    def mapping_ids(self, mapping_ids):
        """Sets the mapping_ids of this TypeMappingExportPayload.


        :param mapping_ids: The mapping_ids of this TypeMappingExportPayload.  # noqa: E501
        :type: list[str]
        """
        if mapping_ids is None:
            raise ValueError("Invalid value for `mapping_ids`, must not be `None`")  # noqa: E501

        self._mapping_ids = mapping_ids

    @property
    def target_data_source(self):
        """Gets the target_data_source of this TypeMappingExportPayload.  # noqa: E501


        :return: The target_data_source of this TypeMappingExportPayload.  # noqa: E501
        :rtype: str
        """
        return self._target_data_source

    @target_data_source.setter
    def target_data_source(self, target_data_source):
        """Sets the target_data_source of this TypeMappingExportPayload.


        :param target_data_source: The target_data_source of this TypeMappingExportPayload.  # noqa: E501
        :type: str
        """

        self._target_data_source = target_data_source

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TypeMappingExportPayload, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TypeMappingExportPayload):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
